# for example python3 xor.py <infile> <keyfile> <outfile>
# 示例 python3 xor.py 原文件 钥匙文件 密文文件
# 会自动获取命令行当前目录, 原文件 钥匙文件 密文文件 请都放于该目录
# 换个说法,三个文件存放于同一目录,cd到该目录后 python3 ***/xor.py infile keyfile outfile
# xor.py 脚本不与原文件同一目录是可以的,只要你记得路径
import time
import sys
import os
Path = os.getcwd()

strsrcin = Path+"/"+sys.argv[1]
strsrckey =Path+"/"+sys.argv[2]
strtarout =Path+"/"+ sys.argv[3]
time_start=time.time()
srcinRead=open(strsrcin,mode="rb")
srcinData=srcinRead.read()
srcinLen=len(srcinData)
tarout_write = open(strtarout,"wb")
srckeyRead=open(strsrckey,mode="rb")
srckeyData=srckeyRead.read()
srckeyLen=len(srckeyData)
if srcinLen > srckeyLen:
    key=srcinLen//srckeyLen*srckeyData+srckeyData[:srcinLen%srckeyLen]
else:
    key=srckeyData[:srcinLen]
    
for i in range(len(key)):
    newByte=key[i]^srcinData[i]
    tarout_write.write(bytes([newByte]))
tarout_write.close()
srcinRead.close()
srckeyRead.close()
time_end=time.time()
print('time cost',time_end-time_start,'s')
